;--------------------------------------------------------------------------
; Cviceni 4 z predmetu IAS
;--------------------------------------------------------------------------
;	Jednoduche programy v asembleru
;--------------------------------------------------------------------------
; ZADANI:
;	Vytvorte jednoduchy program v asembleru, ktery splni nasledujici body:
;
; 1a)	Nactete z klavesnice retezec libovolnych znaku pouzijte funkci
;	Read_String.
;
;	ReadString - nacte retezec z klavesnice a ulozi jej do pameti
;	na misto dane offsetem, ktery je ulozen v registru DX, tj. do
;	registru DX ulozite misto, kam se ma retezec znaku zapsat. Prvni znak
;	tohoto retezce obsahuje informaci o delce retezce => vstupni retezec
;	ma maximalne 255 znaku. Retezec bude mit tvar:
;
;| pocet znaku N | znak 1 | znak 2  |   ...  | znak N |
;        |           |         |                  |
;       [DX]      [DX + 1]  [DX + 2]	...   [DX + N]
;
;	Nezapomente ale, ze registr DX nelze pouzit jako odkaz do pameti...
;	...toto vas ma jen trochu zmast :-)
;
; 1b)	Naleznete vsechna mala pismena anglicke abecedy ('a' - 'z') a
;	prevedete je na velka pismena.
;
; 1c)	Misto znaku, ktere nejsou pismeny, vlozte znak '.' (tecka).
;
; 1d)	Jednotlive modifikace retezce vypiste na obrazovku pomoci funkce
;	Write_String. Muzete take vypsat pouze vysledny retezec... (viz kontrolni vystup).
;
;	Write_String - vypise retezec, ktery je dan offsetem v DX. Retezec musi
;	na svem prvnim miste obsahovat informaci o poctu znaku retezce = vysledek
;	Read_String lze primo vypsat funkci Write_String. Az budete provadet upravy
;	retezce, nemente prvni znak = delka retezce a vse bude OK.
;
; 2)	Znaky v upravenem retezci seradte podle abecedy pomoci libovolneho
;	algoritmu pro radeni - doporucuji nejprve si algoritmus napsat v
;	nejakem programovacim jazyce a pak ho pretvaret do asembleru.
;
; HODNOCENI:
;	1 bod za body 1a,b,c,d
;	1 bod za bod 2
;
; KONTROLNI HODNOTY:
;
;	Zadejte na vstup retezec: '<>zaybxcZAYBXC{}'
;
; VYSTUPEM BY MELY BYT NASLEDUJICI UDAJE:
;
;	Bod 1a): Zadejte retezec znaku: <>zaybxcZAYBXC{}
;	Bod 1bd): <>ZAYBXCZAYBXC{}
;	Bod 1cd): ..ZAYBXCZAYBXC..
;	Bod 2): ....AABBCCXXYYZZ
;
;   NEBO
;
;	Bod 1a): Zadejte retezec znaku: <>zaybxcZAYBXC{}
;	Bod 1bcd): ..ZAYBXCZAYBXC..
;	Bod 2): ....AABBCCXXYYZZ
;
;   NEBO
;
;	Bod 1a): Zadejte retezec znaku: <>zaybxcZAYBXC{}
;	Bod 1bcd,2): ....AABBCCXXYYZZ
;
;--------------------------------------------------------------------------

	bits 16
	%include "rw.asm"

	segment code


;--vjecy--------------------------------------------------------------------

ToUpper:

mov bx, dx
mov cl, [ds:bx]

cmp cl, 0
je @for_end

@for:
inc bx
mov al, [ds:bx]

cmp al, 'a'
jb @not_alpha
cmp al, 'z'
ja @not_alpha

and al, 223	; 223 = ~32 -> zvetsuje to pismeny
mov [ds:bx], al

@not_alpha:

loop @for
@for_end:

    ret



MakeBinecDots:


mov bx, dx
mov cl, [ds:bx]

cmp cl, 0
je @for_end_mbd

@for_mbd:
inc bx
mov al, [ds:bx]


cmp al, 'A'
jb @makedot_mbd
cmp al, 'Z'
jbe @is_alpha_mbd
@makedot_mbd:

mov al, '.'
mov [ds:bx], al

@is_alpha_mbd:
loop @for_mbd
@for_end_mbd:

    ret



QuickSort_r:

push cx			; chci si uchovat parametry top a bottom ...

xor ax, ax
mov al, ch
add al, cl

mov dl, 2
div dl			; al = (bottom + top) / 2

push bx
xor ah, ah
add bx, ax
mov dl, [ds:bx]
pop bx			; dl = pole[(bottom + top) / 2]


@qsort_do:


; ------------------------------ 1. while s i ++

push bx			; cl = i, ch = j
push cx
xor ch, ch
add bx, cx
pop cx

@qsort_while1:
mov al, [ds:bx]		; pole[i]
cmp al, dl
jae @qsort_while1_end	; < pivot (=dl)

inc bx
inc cl			; i ++

jmp @qsort_while1
@qsort_while1_end:

pop bx


; ------------------------------ 2. while s j --

push bx			; cl = i, ch = j

push cx
mov cl, ch
xor ch, ch
add bx, cx
pop cx

@qsort_while2:
mov al, [ds:bx]		; pole[i]
cmp al, dl
jbe @qsort_while2_end	; > pivot (=dl)

dec bx
dec ch			; j --

jmp @qsort_while2
@qsort_while2_end:

pop bx

; ------------------------------ porovnani a prohozeni

cmp cl, ch
ja @qsort_if_end	; if(i <= j)

push bx
push cx
xor ch, ch
add bx, cx
pop cx
mov al, [ds:bx]		; pole[i]
pop bx

push bx
push cx
mov cl, ch
xor ch, ch
add bx, cx
pop cx
mov ah, [ds:bx]		; pole[j]
mov [ds:bx], al		; pole[j] = pole[i]
pop bx

push bx
push cx
xor ch, ch
add bx, cx
pop cx
mov [ds:bx], ah		; pole[i] = pole[j]
pop bx

inc cl
dec ch			; i ++, j --

@qsort_if_end:

cmp cl, ch
jbe @qsort_do_jmp		; while(i <= j)

jmp @qsort_doend

@qsort_do_jmp:
jmp @qsort_do

@qsort_doend:


pop ax	; al = bottom, ah = top

cmp al, ch
jae @qsort_if_botj

push ax
push cx

mov cl, al		; cl = bottom
;mov ch, ch		; ch = j

call QuickSort_r

pop cx
pop ax

@qsort_if_botj:



cmp cl, ah
jae @qsort_if_topi

push ax
push cx

;mov cl, cl		; cl = i
mov ch, ah		; ch = top

call QuickSort_r

pop cx
pop ax

@qsort_if_topi:

    ret



QuickSort:

mov bx, dx
mov ch, [ds:bx]		; ch = konec pole (=delka - 1)
dec ch

mov cl, 0		; cl = zacatek pole (= 0)

inc bx			; bx = pointer do pole (!nemenit)

call QuickSort_r

    ret

;-~vjecy--------------------------------------------------------------------


; Hlavni cast programu.

..start:

	prologue

    mov dx, p_s_buffer
    call Read_String

    call WriteLn
    mov dx, p_s_msg_zadali
    call Print_Str
    mov dx, p_s_buffer
    call Write_String
    call WriteLn


    mov dx, p_s_buffer
    call ToUpper

    call WriteLn
    mov dx, p_s_msg_toupper
    call Print_Str
    mov dx, p_s_buffer
    call Write_String
    call WriteLn


    mov dx, p_s_buffer
    call MakeBinecDots

    call WriteLn
    mov dx, p_s_msg_makebinecdots
    call Print_Str
    mov dx, p_s_buffer
    call Write_String
    call WriteLn


    mov dx, p_s_buffer
    call QuickSort

    call WriteLn
    mov dx, p_s_msg_quicksort
    call Print_Str
    mov dx, p_s_buffer
    call Write_String
    call WriteLn

	; Zde bude vas kod

    call WriteLn
    call WriteLn
    call WriteLn

	epilogue
;--------------------------------------------------------------------------
	segment data


p_s_buffer: resb 256

p_s_msg_zadali			db	"Zadali jste todlenc:  ",'$'
p_s_msg_toupper			db	"S velkejma pismenyma: ",'$'
p_s_msg_makebinecdots	db	"Binec za tecky:       ",'$'
p_s_msg_quicksort		db	"QuickSorted:          ",'$'


;p_s_msg_num			db	"0-",'$'


	; Zde mohou byt vase data (promenne, misto na retezec apod.)
